#! /usr/bin/env bash
# Args: <config-file> <arch> <builder-args> [<repo>]

if [ -z "$BUILD_DIR" ]; then
    BUILD_DIR=build
fi

# Reset env
while read i
do
    unset "$i"
done < <(printenv | cut -d '=' -f 1 | grep -vE '^(PWD|PATH|HOME|BUILD_DIR)$')
printenv &&

# Build
if [ -n "$NO_CLEAN_UP" ]; then
    find '.flatpak-builder/build' '.flatpak-builder/cache' -delete ||
    rm -rf ".flatpak-builder/build/*" ".flatpak-builder/build/.*" '.flatpak-builder/cache'
fi&&
flatpak-builder $3 --arch "$2" --install-deps-from=winebarrels --install-deps-only "$BUILD_DIR" "$1" &&
if [ -z "$4" ]; then
    BUILD_DIR= exec flatpak-builder $3 --arch "$2" --sandbox --rebuild-on-sdk-change --bundle-sources "$BUILD_DIR" "$1"
else
    HASH="$("$(dirname "$0")/hash_modules.py" --installed "$1" "$2" | sed -n '1p')" || exit 0 &&
    BUILD_DIR= exec flatpak-builder $3 --arch "$2" --sandbox --rebuild-on-sdk-change --bundle-sources --repo "$4" -s "WB_HASH='${HASH}'" "$BUILD_DIR" "$1"
fi
